#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ChannelSetCFG.h"
std::auto_ptr<M_ChannelSetCFG> M_ChannelSetCFG::msSingleton(nullptr);

int M_ChannelSetCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ChannelSetCFGData* M_ChannelSetCFG::GetData(std::string ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<std::string, M_ChannelSetCFGData>& M_ChannelSetCFG::GetMapData()
{
	return mMapData;
}

void M_ChannelSetCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ChannelSetCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ChannelSetCFGData data;
		data.mID = element->Attribute("ID");
		data.mDesc = element->Attribute("Desc");
		data.mEnableFastLogin = element->BoolAttribute("EnableFastLogin");
		data.mEnableLocalLogin = element->BoolAttribute("EnableLocalLogin");
		data.mFishLvToOpen = element->IntAttribute("FishLvToOpen");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ChannelSetCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ChannelSetCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ChannelSetCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ChannelSetCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ChannelSetCFGData data;
		LuaCfgHelper::readString(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "Desc", data.mDesc);
		LuaCfgHelper::readBool(L, "EnableFastLogin", data.mEnableFastLogin);
		LuaCfgHelper::readBool(L, "EnableLocalLogin", data.mEnableLocalLogin);
		LuaCfgHelper::readInt(L, "FishLvToOpen", data.mFishLvToOpen);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ChannelSetCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ChannelSetCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ChannelSetCFG* M_ChannelSetCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ChannelSetCFG());
	}
	return msSingleton.get();
}

void M_ChannelSetCFG::Release()
{
	msSingleton.reset(nullptr);
}
